theory Ex_alternative imports Reductions


begin


(* ---------- Definition of graphtransfo ---------- *)

definition disj_condition where
  "disj_condition = 
  \<lparr> appcond = \<lceil>{1, 2, 3, 4}\<rceil> \<lceil>\<and>\<rceil> 
              (\<lceil>\<guillemotleft>1, 2\<guillemotright>\<rceil> \<lceil>\<and>\<rceil> \<lceil>\<guillemotleft>2, 4\<guillemotright>\<rceil> \<lceil>\<and>\<rceil> \<lceil>\<not>\<rceil> \<lceil>\<guillemotleft>1, 3\<guillemotright>\<rceil>) 
               \<lceil>\<or>\<rceil> (\<lceil>\<guillemotleft>1, 3\<guillemotright>\<rceil> \<lceil>\<and>\<rceil> \<lceil>\<guillemotleft>3, 4\<guillemotright>\<rceil> \<lceil>\<and>\<rceil> \<lceil>\<not>\<rceil> \<lceil>\<guillemotleft>1, 2\<guillemotright>\<rceil>),
    ndel = {},
    ngen = {},

    edel = {}, 
    egen = {(1,4)}
  \<rparr>"

lemma fv_path_form_disj_condition: "fv_path_form (appcond disj_condition) = {1, 2, 3, 4}"
by (simp add: disj_condition_def) blast

lemma struct_wf_gt_disj_condition: "struct_wf_gt_utpd disj_condition"
apply (simp add: struct_wf_gt_utpd_def)
apply (simp add: disj_condition_def)
done

locale disj_condition_inj_loc = graph_transformation_swfgrgt_inj_morph_loc _ _ _ disj_condition _

context disj_condition_inj_loc
begin

  (* banality. not interesting because one just adds an edge *)
lemma "applicable_transfo \<and> (apply_transfo_rel gr') \<Longrightarrow>
  (edges gr)^* \<subseteq> (edges gr')^* "
apply (rule edge_set_path_form_reduction)

apply (simp add: disj_condition_def)+

apply (simp add: Disj_form_def)
apply (simp add:  rtrancl_id_trancl pair_insert_trancl insert_Diff_if trancl_insert)
apply blast
done

end -- "context disj_condition_inj_loc"

locale disj_condition_loc = graph_transformation_swfgrgt_loc _ _ _ disj_condition _ _

context disj_condition_loc
begin
  (* not preservation of connectivity, but prevention of creation of new links *)
lemma apply_graphtrans_disj_condition:
  "applicable_transfo \<and> (apply_transfo_rel gr') \<Longrightarrow>
  (edges gr')^* \<subseteq> (edges gr)^* "

apply (erule apply_applicable_transfo_rel)

apply (simp only: apply_graphtrans_rel_def)

apply (simp add: applicable_gm_red_simps fv_path_form_disj_condition del: not_ex cong: conj_cong)
apply (elim exE conjE)
apply (rename_tac gm n1 n2 n3 n4)
apply (simp add: disj_condition_def del: not_ex)
apply (simp only: apply_graphtrans_rel_utpd_def)
apply (simp add: apply_graphtrans_rel_nodes_for_gen_def graphtrans_gen_nodes_init
  graphtrans_gen_nodes_sd_insert graphtrans_gen_nodes_sd_empty)

apply (elim conjE)

apply (elim disjE conjE)
apply (rule_tac A="{(n1, n2), (n2, n4), (n1, n4)}" and B="{(n1, n2), (n2, n4)}" and C="(edges gr)" 
  in rtrancl_mono_subseteq_union)
apply (fastforce simp add:  rtrancl_id_trancl pair_insert_trancl)
apply fastforce
apply fastforce

apply (rule_tac A="{(n1, n3), (n3, n4), (n1, n4)}" and B="{(n1, n3), (n3, n4)}" and C="(edges gr)" 
  in rtrancl_mono_subseteq_union)
apply (fastforce simp add:  rtrancl_id_trancl pair_insert_trancl)
apply fastforce
apply fastforce
done



  (* other proof *)
lemma  "applicable_transfo \<and> (apply_transfo_rel gr') \<Longrightarrow>
  (edges gr')^* \<subseteq> (edges gr)^* "

apply (erule apply_applicable_transfo_rel)

apply (simp only: apply_graphtrans_rel_def)

apply (simp add: applicable_gm_red_simps fv_path_form_disj_condition del: not_ex cong: conj_cong)
apply (clarsimp del: subsetI)
apply (rename_tac n1 n2 n3 n4)

apply (simp add: disj_condition_def del: not_ex)
apply (simp only: apply_graphtrans_rel_utpd_def)
apply (simp add: apply_graphtrans_rel_nodes_for_gen_def graphtrans_gen_nodes_init
  graphtrans_gen_nodes_sd_insert graphtrans_gen_nodes_sd_empty)
apply (clarsimp del: subsetI)
apply (rule_tac A="{n1, n2, n3, n4}" in interior_exterior_decompos_rtrancl_subset)
apply (rule rtrancl_mono)
apply (simp only: exterior_rel_insert exterior_rel_diff exterior_rel_empty) 
apply simp


apply (simp only: rtrancl_id_trancl)
apply (simp only:  interior_rel_empty_dom interior_rel_set_insert interior_rel_elem_r_empty interior_rel_elem_r_insert_if interior_rel_elem_l_empty interior_rel_elem_l_insert_if)

(* This is the script to be applied in principle. Leads to ca. 65.000 cases
apply ((split split_if, intro conjI impI)+, 
  (fastforce simp add:  rtrancl_id_trancl pair_insert_trancl),
  (fastforce simp add:  rtrancl_id_trancl pair_insert_trancl))+
*)
oops

end -- "context disj_condition_loc"



end
