theory Ex_simple_rerouting imports Reductions


begin


(* ---------- Definition of graphtransfo ---------- *)

definition rerouting where
  "rerouting = 
  \<lparr> appcond = \<lceil>{1, 2, 3}\<rceil> \<lceil>\<and>\<rceil> \<lceil>\<guillemotleft>1, 3\<guillemotright>\<rceil> ,
    ndel = {},
    ngen = {},

    edel = {(1,3)}, 
    egen = {(1,2), (2,3)}
  \<rparr>"

definition delete_edge where
  "delete_edge = 
  \<lparr> appcond = \<lceil>{1, 2, 3}\<rceil> \<lceil>\<and>\<rceil> \<lceil>\<guillemotleft>1, 2\<guillemotright>\<rceil> \<lceil>\<and>\<rceil> \<lceil>\<guillemotleft>1, 3\<guillemotright>\<rceil> \<lceil>\<and>\<rceil> \<lceil>\<guillemotleft>2, 3\<guillemotright>\<rceil>,
    ndel = {},  ngen = {},

    edel = {(1,3)},  egen = {}  \<rparr>"


lemma fv_path_form_rerouting: "fv_path_form (appcond rerouting) = {1, 2, 3}"
by (simp add: rerouting_def) blast

lemma fv_path_form_delete_edge: "fv_path_form (appcond delete_edge) = {1, 2, 3}"
by (simp add: delete_edge_def) blast

lemma struct_wf_gt_rerouting: "struct_wf_gt_utpd rerouting"
apply (simp add: struct_wf_gt_utpd_def)
apply (simp add: rerouting_def)
done

print_locale graph_transformation_swfgrgt_inj_morph_loc

locale delete_edge_inj_loc = graph_transformation_swfgrgt_inj_morph_loc _ _ _ delete_edge _

context delete_edge_inj_loc
begin

lemma "applicable_transfo \<and> (apply_transfo_rel gr') \<Longrightarrow>
  (edges gr)^* \<subseteq> (edges gr')^* "
apply (rule edge_set_path_form_reduction)

apply (simp add: delete_edge_def)+

apply (simp add:  rtrancl_id_trancl pair_insert_trancl insert_Diff_if trancl_insert)
done

end -- "context delete_edge_inj_loc"

print_locale graph_transformation_swfgrgt_loc

locale rerouting_loc = graph_transformation_swfgrgt_loc _ _ _ rerouting _ _

context rerouting_loc
begin

lemma apply_graphtrans_rerouting:
  "applicable_transfo \<and> (apply_transfo_rel gr') \<Longrightarrow>
  (edges gr)^* \<subseteq> (edges gr')^* "

apply (erule apply_applicable_transfo_rel)

apply (simp only: apply_graphtrans_rel_def)

apply (simp add: applicable_gm_red_simps fv_path_form_rerouting del: not_ex cong: conj_cong)
apply clarsimp
apply (rename_tac x y n1 n2 n3)

apply (simp add: rerouting_def del: not_ex)
apply (simp only: apply_graphtrans_rel_utpd_def)
apply (simp add: apply_graphtrans_rel_nodes_for_gen_def graphtrans_gen_nodes_init
  graphtrans_gen_nodes_sd_insert graphtrans_gen_nodes_sd_empty)
apply clarify
apply (erule_tac A="{n1, n2, n3}" in interior_exterior_decompos_rtrancl_elems)
apply (rule rtrancl_mono)
apply (simp only: exterior_rel_insert exterior_rel_diff exterior_rel_empty) 
apply simp

apply (rule_tac R="{(n1, n3)}" and S="{(n1, n2), (n2, n3)}" and C="(edges gr) - {(n1, n3)} " 
  in interior_rel_rtrancl_mono_subseteq_union_elim)
apply (clarsimp simp add:  rtrancl_id_trancl pair_insert_trancl)
apply fastforce
apply fastforce

done


  (* alternative proof of the above *)
lemma "applicable_transfo \<and> (apply_transfo_rel gr') \<Longrightarrow>
  (edges gr)^* \<subseteq> (edges gr')^* "
apply (rule edel_egen_reduction)

apply (simp add: rerouting_def)+

apply (clarsimp simp add:  rtrancl_id_trancl pair_insert_trancl)
done

end -- "context rerouting_loc"


lemma simp_insert: "a \<in> A \<Longrightarrow> insert a A = A"
by fast

locale delete_edge_loc = graph_transformation_swfgrgt_loc _ _ _ delete_edge _ _

context delete_edge_loc
begin

lemma "applicable_transfo \<and> (apply_transfo_rel gr') \<Longrightarrow>
  (edges gr)^* \<subseteq> (edges gr')^* "
apply (erule apply_applicable_transfo_rel)

apply (simp only: apply_graphtrans_rel_def)
apply (simp add: applicable_gm_red_simps fv_path_form_delete_edge del: not_ex cong: conj_cong)

apply (elim exE conjE)
apply (rename_tac gm n1 n2 n3)
apply (simp add: delete_edge_def del: not_ex)
apply (simp only: apply_graphtrans_rel_utpd_def)
apply (simp add: apply_graphtrans_rel_nodes_for_gen_def graphtrans_gen_nodes_init
  graphtrans_gen_nodes_sd_insert graphtrans_gen_nodes_sd_empty)

apply (rule_tac A="{(n1, n3)}" and B="{(n1, n2), (n2, n3)}" and C="(edges gr) - {(n1, n3)}" 
  in rtrancl_mono_subseteq_union)
apply (clarsimp simp add:  rtrancl_id_trancl pair_insert_trancl)
apply fast
apply clarsimp
oops
  (* This result synthesizes the problem even better than in the proof below *)

lemma "applicable_transfo \<and> (apply_transfo_rel gr') \<Longrightarrow>
  (edges gr)^* \<subseteq> (edges gr')^* "

apply (erule apply_applicable_transfo_rel)

apply (simp only: apply_graphtrans_rel_def)

apply (simp add: applicable_gm_red_simps fv_path_form_delete_edge del: not_ex cong: conj_cong)
apply clarsimp
apply (rename_tac x y n1 n2 n3)

apply (simp add: delete_edge_def del: not_ex)
apply (simp only: apply_graphtrans_rel_utpd_def)
apply (simp add: apply_graphtrans_rel_nodes_for_gen_def graphtrans_gen_nodes_init
  graphtrans_gen_nodes_sd_insert graphtrans_gen_nodes_sd_empty)
apply clarify
apply (erule_tac A="{n1, n2, n3}" in interior_exterior_decompos_rtrancl_elems)
apply (rule rtrancl_mono)
apply (simp only: exterior_rel_insert exterior_rel_diff exterior_rel_empty) 
apply simp


apply (simp only: rtrancl_id_trancl)
apply (simp only:  interior_rel_empty_dom interior_rel_set_insert interior_rel_elem_r_empty interior_rel_elem_r_insert_if interior_rel_elem_l_empty interior_rel_elem_l_insert_if)

  (* first branch of proof: let Isabelle synthesize the path to the contradiction *)
apply (split split_if, (simp only: if_True if_False)?, intro conjI impI)+
apply simp+
apply ((simp only: if_True if_False)?, intro conjI impI)+
apply (simp add: simp_insert)
apply (clarsimp simp add:  rtrancl_id_trancl pair_insert_trancl2 insert_Diff_if trancl_insert)
apply blast

apply (simp add: simp_insert)
apply (clarsimp simp add:  rtrancl_id_trancl pair_insert_trancl2 insert_Diff_if trancl_insert)
apply blast

apply (simp add: simp_insert)

  (* to have a lower runtime, the second alternative explicitly introduces the relevant case split
apply (case_tac "n1 = n2")
apply clarsimp
apply (intro conjI impI, clarsimp simp add:  rtrancl_id_trancl pair_insert_trancl2 insert_Diff_if trancl_insert)+
apply fast
apply clarsimp apply (elim disjE) apply clarsimp+ apply (rename_tac n2 n3)
 *)
oops


end -- "context delete_edge_loc"


end
